;;;; forever-game-roguelike.lisp

(in-package #:forever-game-roguelike)

(defun start ()
  (sdl2:with-init (:everything)
    (sdl2:with-window (win :flags '(:shown :opengl))
      (sdl2:with-gl-context (gl-context win)
        (let ((controllers ())
              (haptic ()))
          (sdl2:gl-make-current win gl-context)
          (gl:viewport 0 0 800 600)
          (gl:matrix-mode :projection)
          (gl:ortho -2 2 -2 2 -2 2)
          (gl:matrix-mode :modelview)
          (gl:load-identity)
          (gl:clear-color 0.0 0.0 1.0 1.0)
          (gl:clear :color-buffer)

          (sdl2:with-event-loop (:method :poll)
            (:idle
             ()
             (gl:clear :color-buffer)
             (gl:begin :triangles)
             (gl:color 1.0 0.0 0.0)
             (gl:vertex 0.0 1.0)
             (gl:vertex -1.0 -1.0)
             (gl:vertex 1.0 -1.0)
             (gl:end)
             (gl:flush)
             (sdl2:gl-swap-window win))

            (:keyup
             (:keysym keysym)
             (when (sdl2:scancode= (sdl2:scancode-value keysym) :scancode-escape)
               (sdl2:push-event :quit)))

            (:quit () t)))))))
